var CopyURLClipboard = {
    dataFlavor : "text/unicode",
    dataFlavorHTML : "text/html",
    
    onLoad : function(event) {
        // do some initialization
    },
    
    GetClipboardContents : function() {
        var clipboard = Components.classes["@mozilla.org/widget/clipboard;1"].createInstance(Components.interfaces.nsIClipboard);
        var clipboardXfer = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
        
        if (!clipboard || !clipboardXfer) 
        {
            return null;
        }
            
        clipboardXfer.addDataFlavor(this.dataFlavor);
        clipboard.getData(clipboardXfer, clipboard.kGlobalClipboard);

        var s = new Object();
        var sLen = new Object();

        try
        {
            clipboardXfer.getTransferData(this.dataFlavor, s, sLen);
        }
        catch(e)
        {	
            return null;
        }
        
        if (s) s = s.value.QueryInterface(Components.interfaces.nsISupportsString);
        if (s) contents = s.data.substring(0, sLen.value / 2);
        
        return contents;
    },
    
    SetClipboardContents : function(contents) {
        try
        {
            var clipboard = Components.classes["@mozilla.org/widget/clipboard;1"].createInstance(Components.interfaces.nsIClipboard);
            var clipboardXfer = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
            var supportsString = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);

            if (!clipboard || !clipboardXfer || !supportsString) 
            {
                return false;
            }

            supportsString.data = contents;

            clipboardXfer.addDataFlavor(this.dataFlavor);
            clipboardXfer.setTransferData(this.dataFlavor, supportsString, contents.length * 2);

            clipboard.setData(clipboardXfer, null, clipboard.kGlobalClipboard);
            
            return true;
        }
        catch(e)
        {
            return false;
        }
    },
};

window.addEventListener("load", function(e) { CopyURLClipboard.onLoad(e); }, false);